﻿----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
-- @date Feb9th-Mar21th, 2019------------------------------------------
-------------------------------------------

source(Utils.getFilename("lightControl.lua", g_currentModDirectory));

lightControlRegister = {};
lightControlRegister.modDirectory = g_currentModDirectory;
lightControlRegister.inputsXML = getUserProfileAppPath().. "inputBinding.xml";

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
lightControlRegister.version = getXMLString(modDesc, "modDesc.version");
lightControlRegister.title = getXMLString(modDesc, "modDesc.title.en");
lightControlRegister.author = getXMLString(modDesc, "modDesc.author");
delete(modDesc);

print("Load mod: "..lightControlRegister.title.." : v"..lightControlRegister.version.." by "..lightControlRegister.author);

if g_specializationManager:getSpecializationByName("lightControl") == nil then
	if lightControl == nil then 
		print("ERROR: unable to find source file 'lightControl'");
	else 
		for typeName, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
			if typeDef ~= nil and typeName ~= "locomotive" then 
				local isWashable = false;
				local isAnimated = false;
				for name, spec in pairs(typeDef.specializationsByName) do
					if name == "washable" then 
						isWashable = true;
					elseif name == "animatedVehicle" then 
						isAnimated = true;
					end;
				end;
				if isWashable and isAnimated then
					typeDef.specializationsByName["lightControl"] = lightControl;
					table.insert(typeDef.specializationNames, "lightControl");
					table.insert(typeDef.specializations, lightControl);
				end;
			end;
		end;
	end;	
end;

function lightControlRegister:loadMap(savegame)
	lightControl:setKeys();
end;

function lightControlRegister:deleteMap()
end;

function lightControlRegister:mouseEvent(posX, posY, isDown, isUp, button)
end;

function lightControlRegister:keyEvent(unicode, sym, modifier, isDown)
end;

function lightControlRegister:update(dt)
end;

function lightControlRegister:draw()
end;

addModEventListener(lightControlRegister);